#include <windows.h>
#include <shlobj.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "resource.h"
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd){
	BOOL CALLBACK Dlg_Command(HWND,UINT,WPARAM,LPARAM);
	if(FindWindow(NULL,"Command_anywhere")!=NULL)exit(0);
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_COMMAND_ANYWHERE),NULL,Dlg_Command);
	return 0;
}
BOOL CALLBACK Dlg_Command(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	BOOL Dlg_OnCommand(HWND);
	switch(uMsg){
		case WM_INITDIALOG:
			return TRUE;
		case WM_COMMAND:
			switch ((int)LOWORD(wParam)){
				case IDC_BUTTON1:
					Dlg_OnCommand(hwnd);
					break;
			}
			EndDialog(hwnd,IDOK);
			return TRUE;
		case WM_DESTROY:
			return TRUE;
	}
	return (FALSE);
}
void Dlg_OnDestroy(HWND hwnd){
}
void Cmd_OnCmdExit(HWND hwnd){
	EndDialog(hwnd,IDOK);
}
BOOL Dlg_OnCommand(HWND hwnd){
	int get_init(char *,char *);
	char buf[128],str[1024],*pt;
	char setDir[1024],setPath[1024];
	LPMALLOC pMalloc;
	BROWSEINFO bi;
	LPITEMIDLIST idlist;
	int CALLBACK BrowseCallbackProc(HWND,UINT,LPARAM,LPARAM);
	get_init(setDir,setPath);
	if(SUCCEEDED(SHGetMalloc(&pMalloc))){
	    ZeroMemory(&bi,sizeof(bi));
		bi.hwndOwner=hwnd;
		bi.pidlRoot=0;
		bi.pszDisplayName=0;
		bi.lpszTitle="Command_anywhere";
		bi.ulFlags=BIF_RETURNONLYFSDIRS;
		if(strlen(setDir)>0){
			bi.lpfn=BrowseCallbackProc;
			bi.lParam=(LPARAM)setDir;
		}
		else{
			bi.lpfn=NULL;
		}
		idlist=SHBrowseForFolder(&bi);
		if(idlist!=NULL){
			if(!SHGetPathFromIDList(idlist,buf)){
				strcpy(buf,"\0");
			}
			pMalloc->Free(idlist);
		}
		else{
			strcpy(buf,"\0");
		}
		pMalloc->Release();
	}
	if(strlen(buf)>0){
		if(strlen(setPath)>0){
			if(strlen(pt=getenv("PATH"))<sizeof(str)-strlen(setPath)&&strlen(pt)>0){
				strcpy(str,"PATH=");
				strcat(str,pt);
				strcat(str,";");
				strcat(str,setPath);
			}
			else{
				strcpy(str,"PATH=C:\\Windows\\System32;C:\\Windows;C:\\Windows\\System32\\Wbem;");
				strcat(str,setPath);
			}
			_putenv(str);
		}
		_chdir(buf);
		system("cmd.exe");
	}
	return TRUE;
}
int CALLBACK BrowseCallbackProc(HWND hWnd,UINT uMsg,LPARAM lParam,LPARAM lpData){
	if(uMsg == BFFM_INITIALIZED) {
		SendMessage(hWnd,BFFM_SETSELECTION,(WPARAM)TRUE,lpData);
	}
	return 0;
}
int get_init(char *dir,char *path){
	int deleteFoot(char *),get_after(int,char *,char *);
	char str1[1024],str2[1024];
	FILE *stream;
	strcpy(dir,"\0");
	strcpy(path,"\0");
	if((stream=fopen("command_anywhere.txt","r"))==NULL)return(1);
	while(fgets(str1,1024,stream)!=NULL){
		deleteFoot(str1);
		strcpy(str2,str1);
		if(strstr(_strlwr(str2),"dir")!=NULL){
			get_after('=',str1,dir);
		}
		else if(strstr(_strlwr(str2),"path")!=NULL){
			get_after('=',str1,path);
		}
	}
	fclose(stream);
	return(0);
}
int get_after(int c,char *str1,char *str2){
	int i=0;
	char *pt,str[1024];
	strcpy(str2,"\0");
	strcpy(str,str1);
	if((pt=strchr(str,c))==NULL)return(1);
	while(*(pt+i+1)==' ')i++;
	strcpy(str2,pt+i+1);
	return(0);
}
int deleteFoot(char *str){
	int i;
	char *p;
	p=str;
	for(i=strlen(p)-1;i>0;i--){
		if(*(p+i)!='\n'&&*(p+i)!='\r'){
			*(p+i+1)='\0';
			break;
		}
	}
	return(0);
}